{ GRAFIK.INC }

{ fuer GCON2 - 600 x 480 Pixel }

CONST

  cl_White    : Byte = $FF; 
  cl_Black    : Byte = $00; 
  cl_Red      : Byte = $43;
  cl_Green    : Byte = $4C;
  cl_Blue     : Byte = $B0;
  cl_Yellow   : Byte = $4F; 
  cl_Purple   : Byte = $73;
  cl_Aqua     : Byte = $7C; 
  cl_Gray     : Byte = $6A; 
  cl_DarkGray : Byte = $2A; 



  CLR_BLACK   : Byte = 0;
  CLR_RED     : Byte = 1;
  CLR_GREEN   : Byte = 2;
  CLR_YELLOW  : Byte = 3;
  CLR_BLUE    : Byte = 4;
  CLR_PINK    : Byte = 5;
  CLR_CYAN    : Byte = 6;
  CLR_WHITE   : Byte = 7;



{ ****** Text-Attribute ****** }



PROCEDURE ClrScr;
BEGIN
 (* 0CH *)
  WRITE(CHR($0C));
END;




PROCEDURE loesche_Bildschirm;
BEGIN
 (* 0CH *)
  WRITE(CHR($0C));
END;




PROCEDURE Text_Kursor_Aus;
BEGIN
 (* ESC [ ? 2 5 l *)
  WRITE(CHR($1B)); WRITE('['); WRITE('?');WRITE('2'); WRITE('5'); WRITE('l');
END;



PROCEDURE Text_Kursor_Ein;
BEGIN
 (* ESC [ ? 2 5 h *)
  WRITE(CHR($1B)); WRITE('['); WRITE('?');WRITE('2'); WRITE('5'); WRITE('h');
END;



PROCEDURE Kopie_BWS_Aus;
BEGIN
 (* ESC [ ? 2 6 l *)
  WRITE(CHR($1B)); WRITE('['); WRITE('?');WRITE('2'); WRITE('6'); WRITE('l');
END;



PROCEDURE Kopie_BWS_Ein;
BEGIN
 (* ESC [ ? 2 6 h *)
  WRITE(CHR($1B)); WRITE('['); WRITE('?');WRITE('2'); WRITE('6'); WRITE('h');
END;




PROCEDURE Umschalten_Speicherseite;
BEGIN
 (* ESC [ ? 2 7 h *)
  WRITE(CHR($1B)); WRITE('['); WRITE('?');WRITE('2'); WRITE('7'); WRITE('h');
END;




PROCEDURE Text_Farbe_256(col : Byte);
VAR
  C_STR : Str3;
BEGIN
 (* Xterm 256 colors - ESC[38;5;FCOLOR m *)
  C_STR:=ByteToStr(col);
  WRITE(CHR($1B)); WRITE('['); WRITE('3');WRITE('8'); WRITE(';'); WRITE('5'); WRITE(';'); 
  WRITE(C_STR[1]); WRITE(C_STR[2]);WRITE(C_STR[3]); WRITE('m');
END;



PROCEDURE Text_Hintergrund_256(col : Byte);
VAR
  C_STR : Str3;
BEGIN
 (* Xterm 256 colors - ESC[48;5;BCOLOR m *)
  C_STR:=ByteToStr(col);
  WRITE(CHR($1B)); WRITE('['); WRITE('4');WRITE('8'); WRITE(';'); WRITE('5'); WRITE(';'); 
  WRITE(C_STR[1]); WRITE(C_STR[2]);WRITE(C_STR[3]); WRITE('m');
END;





PROCEDURE Text_Farbe_8(TxtClr : Byte);
VAR
  Farbe : Char;
BEGIN

  WRITE(CHR($1B)); WRITE('[');WRITE('3');
  
  { Set TextColor via ANSI }
  CASE TxtClr OF
    0 : Farbe:='0';
    1 : Farbe:='1';
    2 : Farbe:='2';
    3 : Farbe:='3';
    4 : Farbe:='4';
    5 : Farbe:='5';
    6 : Farbe:='6';
    7 : Farbe:='7';
  ELSE  
    Farbe:='0';
  END;

  WRITE(Farbe); ;WRITE('m');

END; { PROCEDURE TextFarbe8 }




PROCEDURE Text_Hintergrund_8(TxtClr : Byte);
VAR
  Farbe : Char;
BEGIN

  WRITE(CHR($1B)); WRITE('[');WRITE('4');
  
  { Set TextColor via ANSI }
  CASE TxtClr OF
    0 : Farbe:='0';
    1 : Farbe:='1';
    2 : Farbe:='2';
    3 : Farbe:='3';
    4 : Farbe:='4';
    5 : Farbe:='5';
    6 : Farbe:='6';
    7 : Farbe:='7';
  ELSE  
    Farbe:='0';
  END;

  WRITE(Farbe); ;WRITE('m');

END; { PROCEDURE TextHintergrund8 }






{ ****** Grafik-Attribute ****** }



PROCEDURE Grafik_setze_Position(CurX, CurY : Word);
VAR
  C_STR1, C_STR2 : Str3;
BEGIN
 (* ESC G Pn1 , Pn2 G *)
  C_STR1:=WordToStr(CurX);
  C_STR2:=WordToStr(CurY);
  WRITE(CHR($1B)); WRITE('G'); WRITE(C_STR1[1]); WRITE(C_STR1[2]);WRITE(C_STR1[3]);
  WRITE(';'); WRITE(C_STR2[1]); WRITE(C_STR2[2]);WRITE(C_STR2[3]); WRITE('G');
END;



PROCEDURE Grafik_setze_Farbe(col : Byte);
VAR
  C_STR : Str3;
BEGIN
 (* ESC G Pn1 C *)
  C_STR:=ByteToStr(col);
  WRITE(CHR($1B)); WRITE('G'); WRITE(C_STR[1]); WRITE(C_STR[2]);WRITE(C_STR[3]); WRITE('C');
END;




PROCEDURE Grafik_zeichne_Punkt(CurX, CurY : Word);
VAR
  C_STR1, C_STR2 : Str3;
BEGIN
 (* ESC G Pn1 , Pn2 P *)
  C_STR1:=WordToStr(CurX);
  C_STR2:=WordToStr(CurY);
  WRITE(CHR($1B)); WRITE('G'); WRITE(C_STR1[1]); WRITE(C_STR1[2]);WRITE(C_STR1[3]);
  WRITE(';'); WRITE(C_STR2[1]); WRITE(C_STR2[2]);WRITE(C_STR2[3]); WRITE('P');
END;



PROCEDURE Grafik_zeichne_Linie(CurX, CurY : Word);
VAR
  C_STR1, C_STR2 : Str3;
BEGIN
 (* ESC G Pn1 , Pn2 L *)
  C_STR1:=WordToStr(CurX);
  C_STR2:=WordToStr(CurY);
  WRITE(CHR($1B)); WRITE('G'); WRITE(C_STR1[1]); WRITE(C_STR1[2]);WRITE(C_STR1[3]);
  WRITE(';'); WRITE(C_STR2[1]); WRITE(C_STR2[2]);WRITE(C_STR2[3]); WRITE('L');
END;




PROCEDURE Grafik_zeichne_Rechteck(CurX, CurY : Word);
VAR
  C_STR1, C_STR2 : Str3;
BEGIN
 (* ESC G Pn1 , Pn2 R *)
  C_STR1:=WordToStr(CurX);
  C_STR2:=WordToStr(CurY);
  WRITE(CHR($1B)); WRITE('G'); WRITE(C_STR1[1]); WRITE(C_STR1[2]);WRITE(C_STR1[3]);
  WRITE(';'); WRITE(C_STR2[1]); WRITE(C_STR2[2]);WRITE(C_STR2[3]); WRITE('R');
END;





PROCEDURE Grafik_zeichne_volles_Rechteck(CurX, CurY : Word);
VAR
  C_STR1, C_STR2 : Str3;
BEGIN
 (* ESC G Pn1 , Pn2 F *)
  C_STR1:=WordToStr(CurX);
  C_STR2:=WordToStr(CurY);
  WRITE(CHR($1B)); WRITE('G'); WRITE(C_STR1[1]); WRITE(C_STR1[2]);WRITE(C_STR1[3]);
  WRITE(';'); WRITE(C_STR2[1]); WRITE(C_STR2[2]);WRITE(C_STR2[3]); WRITE('F');
END;
                                              




PROCEDURE Grafik_zeichne_Kreis(Radius : Word);
VAR
  C_STR : Str3;
BEGIN
 (* ESC G Pn1 K *)
  C_STR:=WordToStr(Radius);
  WRITE(CHR($1B)); WRITE('G'); WRITE(C_STR[1]); WRITE(C_STR[2]); WRITE(C_STR[3]);
  WRITE('K');
END;





PROCEDURE Grafik_zeichne_vollen_Kreis(Radius : Word);
VAR
  C_STR : Str3;
BEGIN
 (* ESC G Pn1 V *)
  C_STR:=WordToStr(Radius);
  WRITE(CHR($1B)); WRITE('G'); WRITE(C_STR[1]); WRITE(C_STR[2]); WRITE(C_STR[3]);
  WRITE('V');
END;


                                        



